(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["autoSortingArray"] = factory();
	else
		root["autoSortingArray"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	    value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	function convertArrayToArrayAndMap(inputArray, keyName) {
	
	    var sortedArray = [];
	    var map = {};
	    inputArray.sort(function (a, b) {
	        if (!b.count || !a.count) return 1;
	        return b.count - a.count;
	    });
	
	    // console.log(inputArray);
	
	    inputArray.forEach(function (item, index) {
	        // console.log(index);
	        if (Object.getPrototypeOf(item) === Object.prototype) {
	            item.index = index;
	        } else {
	            item = { value: item, index: index };
	        }
	
	        sortedArray[index] = _extends({ count: item.count || 1 }, item);
	        if (keyName !== undefined) {
	            map[item[keyName]] = sortedArray[index];
	        }
	    });
	
	    //  console.log(map);
	    return { array: sortedArray, map: map };
	}
	
	function sortArray(index, holder) {
	    var array = holder.array;
	
	
	    var currentIndex = index;
	
	    for (var i = index - 1; i >= 0; i--) {
	        var temp = array[i];
	        var current = array[currentIndex];
	        if (current.count > temp.count) {
	            current.index = temp.index;
	            temp.index = currentIndex;
	
	            array[i] = current;
	            array[currentIndex] = temp;
	            currentIndex = i;
	        } else {
	            break;
	        }
	    }
	}
	
	var AutoSortingArray = function () {
	    function AutoSortingArray(inputArray, keyName) {
	        _classCallCheck(this, AutoSortingArray);
	
	        if (inputArray === undefined) throw new Error("constructor has missing values");
	
	        var _convertArrayToArrayA = convertArrayToArrayAndMap(inputArray, keyName),
	            array = _convertArrayToArrayA.array,
	            map = _convertArrayToArrayA.map;
	
	        this.holder = { array: array, map: map };
	    }
	
	    _createClass(AutoSortingArray, [{
	        key: "peek",
	        value: function peek(index) {
	            var item = this.holder.array[index];
	            return item;
	        }
	    }, {
	        key: "peekByKey",
	        value: function peekByKey(key) {
	            var item = this.holder.map[key];
	            return item;
	        }
	    }, {
	        key: "get",
	        value: function get(index) {
	            var item = this.holder.array[index];
	            ++this.holder.array[index].count;
	            sortArray(index, this.holder);
	            return item;
	        }
	    }, {
	        key: "getByKey",
	        value: function getByKey(key) {
	            var item = this.holder.map[key];
	            // console.log(item);
	            // console.log(this.holder.array);
	            return this.get(item.index);
	        }
	    }, {
	        key: "getArray",
	        value: function getArray() {
	            return this.holder.array;
	        }
	    }]);
	
	    return AutoSortingArray;
	}();
	
	exports.default = AutoSortingArray;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=auto-sorting-array.js.map